CON
  _clkmode        = xtal1 + pll16x
  _xinfreq        = 5_000_000
    OneSecond = 80_000_000  

  Left            = 10       '<-- Audio Out pins
  Right           = 11
  TestLed = 0 

OBJ

  synth : "pm_synth_20"
  disp  : "VGA_Text"         'or "VGA_Text" or "PC_Text"  

VAR
  LONG i
  LONG Note
  Long Channel
  Long Instrument

PUB Main
  disp.start(16)   
  disp.str(string(13,"   PM SYNTH ...",13,$C,5," FM Synthesizer Demo ",$C,1,13))  

  synth.start(Left,Right,2)                             'start synth with 20 voices
  {
      List of commands for pm_synth_20
      ================================
      
      start(Lpin, Rpin, Cogs) : okay ==> start synthesizer in a COG
      stop == stop synthesizer
      noteOn(key, chan, vel)==> turn on sound (pitch,midichannel,velocity) 
      noteOff(key, chan)==>turn off sound
      prgChange(num, chan)==> change the instrument in a channel, instruments: 0..127
      volContr(vo, chan)==> volume control
      panContr(pa, chan)
      allOff ==> all channels off

      channel 10 ==> drum channel, every note plays another sound
  }

  disp.str(string(13,"test chords")) 
  'test chords  
  Note:=72
  Channel:=0
  Instrument:=49
  repeat 8
    synth.prgChange(Instrument,Channel)
    synth.noteOn(Note,Channel,100)   'pitch,midichannel,velocity  
    synth.noteOn(Note+4,Channel,100)  'quart  
    synth.noteOn(Note+7,Channel,100)  'septime  
    waitcnt(OneSecond+cnt)
    synth.noteOff(Note,Channel)   
    synth.noteOff(Note+4,Channel)   
    synth.noteOff(Note+7,Channel)   
    waitcnt(OneSecond*2+cnt)
    Instrument+=2
    !outa[TestLed]
    
  disp.str(string(13,"test drums"))  
  'test drums  
  Channel:=9 'channel 9 is the drum channel
  repeat 16
    synth.noteOn(40,Channel,100)   'SnareDrum,midichannel,velocity  
    waitcnt(OneSecond/2+cnt)
    synth.noteOff(40,Channel)   
    synth.noteOn(40,Channel,100)   'SnareDrum,midichannel,velocity  
    synth.noteOn(44,Channel,120)   'HiHat,midichannel,velocity  
    waitcnt(OneSecond/2+cnt)
    synth.noteOff(40,Channel)   
    synth.noteOff(44,Channel)   
    !outa[TestLed]

  
  dira[TestLed]:=1   
  disp.str(string(13,"fast note on/off"))
  'fast note on/off test
  Channel:=1
  Note:=70
  i:=0
  repeat 50
    disp.out($0A) 'set x position
    disp.out(28) ' to 28
    disp.dec(i++)
    synth.noteOn(Note,Channel,100)   'pitch,midichannel,velocity
    waitcnt(OneSecond/20+cnt)
    synth.noteOff(Note,Channel)  
    waitcnt(OneSecond/20+cnt)

  disp.str(string(13,"different instruments"))  
  'test different instruments  
  Note:=80
  Channel:=0
  Instrument:=0
  repeat 127
    synth.prgChange(Instrument,Channel)
    synth.noteOn(Note,Channel,100)   'pitch,midichannel,velocity  
    waitcnt(OneSecond/10+cnt)
    synth.noteOff(Note,Channel)   
    waitcnt(OneSecond/10+cnt)
    disp.out($0A) 'set x position
    disp.out(28) ' to 28
    disp.dec(Instrument)
    Instrument++
    !outa[TestLed]

  disp.str(string(13,"play notes in upcounting sequence"))  
  'play notes in an upcounting sequence
  Channel:=2
  Note:=60
  i:=1
  Instrument:=85          'instrument = a kind of flute?
  synth.prgChange(Instrument,Channel)
  repeat 50
    synth.noteOn(Note+i,Channel,200)   'pitch,midichannel,velocity       
    waitcnt(OneSecond/20+cnt)
    synth.noteOff(Note+i,Channel)  
    waitcnt(OneSecond/20+cnt)  
    i++
    !outa[TestLed]
    
  synth.allOff
  synth.stop    